var PROT_globalStore;
var PROT_listManager;
var PROT_phishingWarden;
function PROT_Application() {
PROT_globalStore =
new PROT_GlobalStore("extensions.google.safebrowsing.v1.");
var threadConfig = {
"interleave": true,
"runtime": 80,
"delay": 400,
};
var threadQueue = new TH_ThreadQueue(threadConfig);
PROT_listManager = new PROT_ListManager(threadQueue);
PROT_phishingWarden = new PROT_PhishingWarden(PROT_listManager);
function initListManager() {
var appDir = new PROT_ApplicationDirectory();
if (!appDir.exists())
appDir.create();
PROT_listManager.setAppDir(appDir.getAppDirFileInterface());
PROT_listManager.maybeStartManagingUpdates();
if (G_GDEBUG) {
TEST_G_Base64();
TEST_PROT_EnchashDecrypter();
TEST_G_ObjectSafeMap();
TEST_G_CryptoHasher();
TEST_PROT_URLCanonicalizer();
TEST_PROT_TRTable();
TEST_PROT_ListManager();
TEST_PROT_PhishingWarden();
TEST_G_Preferences();
TEST_PROT_TRFetcher();
TEST_G_Observer();
TEST_G_File();
TEST_PROT_WireFormat();
}
};
new G_ObserverServiceObserver("profile-after-change",
initListManager,
true /* unregister after observing */);
}
function PROT_ApplicationDirectory() {
this.debugZone = "appdir";
this.appDir_ = G_File.getProfileFile();
this.appDir_.append(PROT_globalStore.getAppDirectoryName());
G_Debug(this, "Application directory is " + this.appDir_.path);
}
PROT_ApplicationDirectory.prototype.exists = function() {
return this.appDir_.exists() && this.appDir_.isDirectory();
}
PROT_ApplicationDirectory.prototype.create = function() {
G_Debug(this, "Creating app directory: " + this.appDir_.path);
try {
this.appDir_.create(Ci.nsIFile.DIRECTORY_TYPE, 0700);
} catch(e) {
G_Error(this, this.appDir_.path + " couldn't be created.");
}
}
PROT_ApplicationDirectory.prototype.getAppDirFileInterface = function() {
return this.appDir_;
}
